﻿Type=StaticCode
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.	
	Public Language_Type As String
	Dim SFC As StringFunctions
End Sub

Public Sub  Apo(sFieldString As String) As String
	Return sFieldString.Replace ("'", "''")
End Sub

Public Sub Instr(Text As String, Caracter As String) As String
    Return Text.IndexOf(Caracter)
End Sub

Public Sub Left (StringText As String, Length As Long) As String
	

	Return(SFC.Left(StringText, Length))
End Sub

Public Sub Right (StringText As String, Length As Long) As String
	
	Return(SFC.Right(StringText, Length))
	
End Sub

Public Sub  Mid (StringText As String, Start As Int, Length As Int) As String
	
	
	Return(SFC.Mid(StringText, Start ,Length))
End Sub

Public Sub  iif (Value1 As Boolean, Value2 As String, Value3 As String) As String
	Dim Final_Value As String 
	
	If Value1 = True Then
		Final_Value = Value2
	Else
		Final_Value = Value3
	End If
	
	Return(Final_Value)
	
End Sub

Public Sub GetCode(Value As String ) As String 
	Dim I As Long
	Dim GetBracket As String 
	Dim Final_Value As String 
	Dim Get_Value As String
	
		
	Dim NumberOfBracket As Int
	NumberOfBracket = 0
	For I = 1 To SFC.Len(SFC.Trim(Value))
		If Instr(Value, "))") > 0 Then
			If Mid(Value, SFC.Len(Value) - I + 1, 1) = "(" Then
				NumberOfBracket = NumberOfBracket + 1
				If NumberOfBracket = 2 Then
					Exit
				End If
			End If
		Else
			If Mid(Value, SFC.Len(Value) - I + 1, 1) = "(" Then
				Exit
			End If
		End If
	Next
	
	If Instr(Value, "))") > 0 Then
		Get_Value = Right(Value, I - 1)
		Get_Value = Left(Get_Value, SFC.Len(Get_Value) - 1)
		Get_Value = SFC.Trim(Get_Value)
	Else
		Get_Value = TrimString(4, Right(Value, I), ")")
		Get_Value = TrimString(4, Right(Get_Value, I), "(")
		Get_Value = SFC.Trim(Get_Value)
	End If
	
	Return Get_Value
End Sub

Public Sub TrimString(TrimType As Int, str As String, TrimStr As String) As String 
	
	Dim I As Int
	Dim GetStr As String
	Dim ProperCase As String
	Dim ProperCaseB As String
	ProperCase = str
	ProperCaseB = TrimStr
'''''	str = SFC.Upper(str)
'''''	TrimStr = SFC.Upper(TrimStr)
	
	If TrimType = 1 Then 'trim "_"
	    For I = 1 To SFC.Len(str)
	        If Mid(str, I, 1) = "_" Then
	            GetStr = GetStr & " "
	        Else
	            
	            GetStr = GetStr & Mid(str, I, 1)
	        
	        End If
	    Next
	    Return GetStr
		
	Else If TrimType = 2 Then
		If Instr(SFC.upper(str), SFC.upper(TrimStr)) > 0 Then
			Return SFC.Mid(str, 1, SFC.InString(str, TrimStr) - 1) & SFC.Mid(str, Instr(str, TrimStr) + SFC.Len(TrimStr), SFC.Len(str) - Instr(str, TrimStr) - SFC.Len(TrimStr) + 1)
	    End If
		
	Else If TrimType = 3 Then
		For I = 1 To SFC.Len(str)
			If SFC.Mid(SFC.upper(str), I, 1) = SFC.upper(TrimStr) Or Asc(Mid(SFC.upper(str), I, 1)) = 0 Then
	            GetStr = GetStr & ""
	        Else
	            GetStr = GetStr & Mid(str, I, 1)
	        End If
	    Next
	    Return GetStr
		
	Else If TrimType = 4 Then
	    For I = 1 To SFC.Len(ProperCase)
	        If Mid(ProperCase, I, 1) = ProperCaseB Then
	            GetStr = GetStr & ""
	        Else
	            GetStr = GetStr & Mid(ProperCase, I, 1)
	        End If
	    Next
	    Return GetStr
	End If
End Sub

Public Sub GetCodePropercase(FieldValue As String) As String
	Dim I As Long
	Dim NumberOfBracket As Int
	Dim Final_Value As String 
	
	NumberOfBracket = 0
	For I = 1 To SFC.Len(SFC.Trim(FieldValue))
		If Instr(FieldValue, "))") > 0 Then
			If Mid(FieldValue, SFC.Len(FieldValue) - I + 1, 1) = "(" Then
				NumberOfBracket = NumberOfBracket + 1
				If NumberOfBracket = 2 Then
					Exit
				End If
			End If
		Else
			If SFC.Mid(FieldValue, SFC.Len(FieldValue) - I + 1, 1) = "(" Then

				Exit
			End If
		End If
		
	Next
	If Instr(FieldValue, "))") > 0 Then
		Final_Value = SFC.Right(FieldValue, I - 1)
		Final_Value = SFC.Left(Final_Value, SFC.Len(Final_Value) - 1)
		Return SFC.Trim(Final_Value)
	Else
		Final_Value = TrimString(4, SFC.Right(Final_Value, I), ")")
		Final_Value = TrimString(4, SFC.Right(Final_Value, I), "(")
		Return SFC.Trim(Final_Value)
	End If
	
End Sub 

Public Sub Get_Description(Value As String) As String

	Dim GCode As String
    
	GCode = GetCodePropercase(Value)
    
	Return SFC.Trim(Value.Replace("(" & GCode & ")", ""))
	
End Sub

Public Sub EditTextLostFocus(Obj As EditText , KeyFormat As Double) As Boolean
	
	If KeyFormat = "301" And Obj.Text <> "" Then
	    If IsNumber(Obj.Text) = True And Obj.Text.Length  = 8 Then
	        Obj.Text = Left(Obj.Text, 2) & "-" & Mid(Obj.Text, 3, 2) & "-" & Right(Obj.Text, 4)
	        If ValidDate(Obj.Text) = False Then
				Msgbox ("Invalid date format.", "Invalid Date")
				Obj.Text= ""
	            Obj.RequestFocus
				Return False
	        End If
	    Else If Obj.Text.Length = 10 Then
	        If ValidDate(Obj.Text) = False Then
				Msgbox ("Invalid date format.", "Invalid Date")
				Obj.Text= ""
	            Obj.RequestFocus
				Return False
	        End If
		Else
			Msgbox ("Invalid date format.", "Invalid Date")
			Obj.Text= ""
			Obj.RequestFocus
			Return False
		End If
	End If
	
	Return True
End Sub

Public Sub ValidDate(ChkDate) As Boolean
   DateTime.DateFormat = "dd-MM-yyyy"      'or what ever format is required
   
   Try
      DateTime.DateParse(ChkDate)
      Return True
'      Msgbox("good date","")
   Catch
      Return False
'      Msgbox("bad date","")
   End Try
   
End Sub

Public Sub Get_Date As String 
	Dim D As String 

	DateTime.DateFormat = "dd-MM-yyyy"
	
	D = Convert_Month(NumberFormat(DateTime.GetDayOfMonth(DateTime.Now),2,0) & "-" & NumberFormat(DateTime.GetMonth(DateTime.Now),2,0) & "-" & DateTime.GetYear(DateTime.Now))
	
	Return D
End Sub

Public Sub YYYYMMDD As String 
	Dim D As String 
	
	DateTime.DateFormat = "dd-MM-yyyy"
	D = DateTime.DateParse(DateTime.GetDayOfMonth(DateTime.Now) & "-" & DateTime.GetMonth(DateTime.Now) & "-" & DateTime.GetYear(DateTime.Now))
	DateTime.DateFormat = "yyyyMMdd"
	
	Return DateTime.Date(D)
End Sub

Public Sub HHMM As String
		
	Dim T As String
	
'''''	T = NumberFormat(DateTime.GetHour(DateTime.Now),2,0) & ":" & NumberFormat(DateTime.GetMinute(DateTime.Now),2,0)
	T = DateTime.TimeParse(DateTime.Time(DateTime.Now))
	DateTime.TimeFormat = "HHmm"
	
	Return DateTime.Time(T)
		
End Sub

Public Sub Get_Time As String
		
	Dim T As String
	
	T = NumberFormat(DateTime.GetHour(DateTime.Now),2,0) & ":" & NumberFormat(DateTime.GetMinute(DateTime.Now),2,0)
	Return T
		
End Sub

Public Sub Get_Price_From_UOM (UOM_Value As String, Search_For As String) As Double
	Dim Get_Split_Text() As String 
	Dim Get_After_Replace As String 
	Dim Final_Values As Double 
	Dim I As Int
	
	Get_Split_Text = Regex.Split("\|",UOM_Value)
	
	For I = 0 To Get_Split_Text.Length - 1
		If Instr(Get_Split_Text(I), Search_For) <> - 1 Then
			Get_After_Replace = Get_Split_Text(I).Replace("\","")
			Final_Values = GetCode(Get_After_Replace)
			Exit
		End If
	Next
	
	If Final_Values <> 0 Then
		Return Final_Values
	End If
End Sub

Public Sub Convert_Month(Date As String) As String 
	
	If SFC.Mid(Date,4,2) = "01" Then
		Return SFC.Left (Date,3) & "Jan" & SFC.Right (Date,5)
	else if SFC.Mid(Date,4,2) = "02" Then
		Return SFC.Left (Date,3) & "Feb" & SFC.Right (Date,5)
	else if SFC.Mid(Date,4,2) = "03" Then
		Return SFC.Left (Date,3) & "Mar" & SFC.Right (Date,5)
	else if SFC.Mid(Date,4,2) = "04" Then
		Return SFC.Left (Date,3) & "Apr" & SFC.Right (Date,5)
	else if SFC.Mid(Date,4,2) = "05" Then
		Return SFC.Left (Date,3) & "May" & SFC.Right (Date,5)
	else if SFC.Mid(Date,4,2) = "06" Then
		Return SFC.Left (Date,3) & "Jun" & SFC.Right (Date,5)
	else if SFC.Mid(Date,4,2) = "07" Then
		Return SFC.Left (Date,3) & "Jul" & SFC.Right (Date,5)
	else if SFC.Mid(Date,4,2) = "08" Then
		Return SFC.Left (Date,3) & "Aug" & SFC.Right (Date,5)
	else if SFC.Mid(Date,4,2) = "09" Then
		Return SFC.Left (Date,3) & "Sep" & SFC.Right (Date,5)
	else if SFC.Mid(Date,4,2) = "10" Then
		Return SFC.Left (Date,3) & "Oct" & SFC.Right (Date,5)
	else if SFC.Mid(Date,4,2) = "11" Then
		Return SFC.Left (Date,3) & "Nov" & SFC.Right (Date,5)
	else if SFC.Mid(Date,4,2) = "12" Then
		Return SFC.Left (Date,3) & "Dec" & SFC.Right (Date,5)
	End If
	
End Sub
